/*
24/02/2014
RE test 18f26K20 avec programme du 18f26K22 modi pour
Test avec Grafique ..OK
Nota: necessite un buffer de > 504 bytes (ici 640)
inclure fichier linker 18f26k20_Nokia5110.lkr dans le projet 
// grand tableau LCDcache
// 24-02-2014 pour Nokia 5110   640 bytes
DATABANK  NAME=GrossBank	 START=0x900  	END=0xB7F
SECTION    NAME=GrossBank    RAM=GrossBank

verif dans le fichier 18F26K20_Nokia_5110_graf.map
 GrossBank      udata   0x000900       data   0x000280

Suppresion de la sortie RA3 pour alimenter le nokia LCD,car
niveau de sortie 1=2,6V ..insuffisant
LCD OK si aliment en 3,3V..

17/02/2014
Impossible d'afficher sur le nokia LCD 5110


*/
#define Directory "C:\_C18\_MesProjets_C18\_18F26K20"
#define Versus "Versus 140224 C18   "
#define Projet  "18F26K20_test_Nokia_5110_Graf.mcp"
#define Source  "18F26K20_test_Graf_Nokia_5110_140224.c"

/* =========== HARDWARE ====================
PIC 18F26K20  microchip  

Interface Max3222 pour liaison UART TTL <-> RS232 19200 bauds
PortB
B0  21  
B1  22  
B2  23 
B3  24
B4  25 
B5  26 
B6  27 ICSP
B7  28 ICSP

PORTA
A0   2
A1   3
A2   4
A3   5 ---> Power ON LCD
A4   6 ---> R + Led rouge--+3.3V
A5   7

PORTC
C0   11  -> 5.CS  - Chip Select Enable
C1   12  -> 4.D/C - Data Command input
C2   13  -> 8.RES - reset
C3   14  -> 2.SCK - Serial ClocK
C4   15  -> 3.SDI - Serial Data Input-
C5   16  NC
C6   17  TX  1 de DS275 7  RX  2 RS232   UART Harware
C7   18  RX  3 de DS275 5  TX  3 RS232   UART Hardware

// LCD nokia 3310 sur PORT C
#define nokia_CS    LATCbits.LATC0
#define nokia_DC    LATCbits.LATC1
#define nokia_RESet LATCbits.LATC2
#define nokia_SCLK  LATCbits.LATC3
#define nokia_SDA   LATCbits.LATC5
#define nokia_Power   LATAbits.LATA3 <- non utulisee car 2,6V seulement ..INSUFFISANT


/* LCD nokia 5110 sur PORT C
#define nokia_CS    LATCbits.LATC0
#define nokia_DC    LATCbits.LATC1
#define nokia_RESet LATCbits.LATC2
#define nokia_SCLK  LATCbits.LATC3
#define nokia_SDA   LATCbits.LATC5
#define nokia_Power   LATAbits.LATA3
*/

/*
LCD nokia 5110 LPH 7366-1 8 pins :
1.Gnd
2.B.L   Back Light blue leds via 150 ohms --- 2,2K -- +3.3V
3.VCC   <---------------------  3.3V
4.CLK   Clock           <---  1K ---RC3
5.Din   Data Input      <---  1K----RC5
6.D/C   1=Data 0=Cde    <---  1k----RC1
7.CE    Chip Enable =0  <---  1k----RC0
8.RES   reset=0         <---  1k----RC2
*/


#include "p18f26K20.h"
#include <stdio.h> // pour _H_USART output !
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART1
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>

//linker uses this file  "18f26k22_Nokia5110.lkr"


#define Nokia5110
#define With_Grafique


#ifdef  Nokia5110
#include "Nokia5110/Nokia_5110.h"
#endif

#include "Delay16M/Delays_16Mhz.h"

/* PIC18F26K22 Configuration Bit
 Alternative Microchip MPLAB IDE Menu Configure -> Configuration Bits
 configuration bits set in code
*/
#define OSCILLATEUR_INTERNE


#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF            // CONFIG1H
#else
#pragma config FOSC = XT, IESO=OFF ,FCMEN=OFF, LPT1OSC=OFF
#endif
#pragma config PWRT=OFF,BOREN=OFF,WDTEN=OFF
#pragma config PBADEN=OFF,CCP2MX=PORTC
#pragma config MCLRE=ON,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H

// config vue par pickit2 : 2800 3C19 9D00 0084 C00F E00F 400F 

const long BAUDS=19200;

#ifndef Byte
#define Byte unsigned char
#endif

#define DureeCycle 5 // * 2 diziemes de secondes => 1,0sec

#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define Led_Rouge    PORTAbits.RA4
#define Allume 0
#define Eteint 1
#define MAX_LEN	80		// taille buffer


#define putd(c) putchar(c+48)
#define putchar(c) nokia_printchar(c,0)

#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

//static ram unsigned char  LcdCache [768]; 
//static ram unsigned char  LcdCache [64]; //need 768 !

/*	Variables globales */

unsigned int count;
char Texte[MAX_LEN]; 
char *txt;
unsigned char ValFt1[32]; 
unsigned char ValFt2[32];
unsigned char Entree[17]="1234567890123456";
unsigned char *valtxt;
char buffer[40]="00000000000000000000000";	// buffer de reception 
volatile unsigned char C1;
char received;
char *ptlec;		// pointeur de lecture 
char *ptecr;		// pointeur d'ecriture 
unsigned int CptCars;
unsigned int SaisieOk;
//unsigned char Drapeaux ;     // 8 flags
struct chbits {
                 unsigned running:1;
                 unsigned standby:1;
                 unsigned elligible:1;
                 unsigned Accumule:1;
                 unsigned Blc:1;
                 unsigned OneShot:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               } Drapeaux;
               
/*
 static ram unsigned int   LcdPos = 0;
  unsigned short newline=0;
  int ddram;
 unsigned char charsel,char_row,charpos,chardata,plot_value;
 long plot_value32,plot_llsb,plot_ulsb,plot_lmsb,plot_umsb;          
*/

unsigned int TimeEcoule;
Byte receive;
char error;
char EtatCf;
signed char Ve;
unsigned int  NbMes;
Byte Allume_led;
Byte Dummy;
unsigned int i,j,k,l ;
unsigned char s_count = 0;
unsigned int M;
float f1,f2;
unsigned int x,y;
unsigned int toggle;

rom const char chaine0[]="...";
rom const char chaine1[]="Port comm 19200 ouvert ... String en ROM \r\n";
rom const char chaine2[]="C18: 18F26K20_test_Graf_Nokia_5110_140224.c \r\n";
rom const char chaine3[]="ESC pour sortir\r";
rom const char chaine4[]="J= ";
rom char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4 };

                     //   12345678901234
rom const char nokia00[]="18F26K20 AaZz ";
rom const char nokia01[]="LCD 5110 6x14c";
rom const char nokia02[]="24/02/2014 C18";
rom const char nokia03[]="Vcc=3.3 F=16Mz";
rom const char nokia04[]="12345678901234";
rom const char nokia05[]="6em ligne     ";
rom const char nokia06[]="J=......... Pt";
rom const char nokia07[]="T=00.000C    ";
rom const char nokia08[]="              ";
rom const char nokia09[]="..............";

rom char *Nokia_Str[]={nokia00,nokia01,nokia02,nokia03,nokia04,nokia05,nokia06,
      nokia07,nokia08,nokia09};

#pragma romdata EEP_=0xF00000

rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          "18F26K20_test_Nokia_5110_LCD. \r",//0
          "Port Com 19200b & Init HARD.  \r",//20  avec terminateur zero
          "Boucle en 1 Sec   <ESC> exit  \r",//40  avec terminateur zero
          "Avec UART HARDWARE........... \r",//60  avec terminateur zero
          "18F26K20  Fosc=16Mhz 24/02/14 \r", //80  sans terminateur
          "paulfjujo@free.fr             \r", //A0  sans terminateur
          "MPLAB IDE V8.92  C18 v3.45.01 \r", //C0  sans terminateur
          "Nokia 5110 84x48 6Lx14cars\r\n"  //E0 avec terminateur zero
          };
#pragma romdata



// Table 5x7   84* rows * 5 bytes= 480 bytes
//extern rom const char TABLE_car[480]=
//extern static unsigned char  LcdCache[640]; //need 640 !

/*
void Delay_uS(unsigned int x);
void Delay_mS(unsigned int cnt);
void Delay_1S(void);
*/

void Octet2Hex(unsigned char number);
void Decompile_byte(Byte un);
void Write_Word(unsigned int M,char Sign,char Bold);   // Bold pour Nokia LCD
void Remplis_N_blancs(Byte N);
void fltToa (float x, unsigned char *str,char precision);
void print_flt(float W,int NbDeci,char Bold);  // Bold pour Nokia LCD
void Print_Decompose_32bits (void);
void Tempo(long val);
void Init_Hardware(void) ;
void Init_Timer1(void);

void Test_PortC();
void Init_UART1(void);
int PutStr_RS(char *s);
void Put_RS(char * untel);
void CRLF(void);
void InterruptHandlerHigh (void);

/*

void    nokia_init(void);
void    nokia_write_command(char nokia_cmd);
void    nokia_write_data(char nokia_data);
void    nokia_write_byte(char nokia_byte);
void    nokia_gotoxy(unsigned char Xnokia, unsigned char Ynokia);
void    nokia_erase_y(unsigned char Ynokia);
void    nokia_erase_x(unsigned char Xnokia);
void    nokia_printchar(unsigned char cvar, char Bold);
//void    nokia_printBigChiffre(unsigned char cvar ,char xB,char yB); // size 12x16
void    nokia_print_str(char *ptr,char Bold);         // size 5x7 ou 10x7
void    nokia_CLS(void);
void    nokia_write_data_inv(char nokia_data_inv);
void    nokia_clear_screen(void);
void    nokia_clear_xy(unsigned char Xnokia, unsigned char Ynokia);
void    nokia_print_uparrow(void);
void    nokia_print_downarrow(void);
void    nokia_print_leftarrow(void);
void    nokia_print_rightarrow(void);
void    nokia_print_degree(void);
void    nokia_print_lowbatdegree(void);
void    nokia_bargraph_H(char Ligne,int Value);

#ifdef With_Grafique
void    nokia_clean_ddram(void);
void    nokia_plot(unsigned char Xnokia,unsigned char plot_value8,unsigned char Dot);
void    nokia_pixel(int pixelX,int pixelY,int pixelMode);
void    nokia_line(int x1,int y1,int x2,int y2,int lineMode);
void    nokia_rect(int x1,int y1,int x2,int y2,int rectMode);
void    nokia_circle(int centerX,int centerY,int radius,int circleMode);
void    nokia_redraw(void);
#endif

*/




//gestionnaire d'interruption
//------------------------------
// High priority interrupt vector
#pragma code InterruptVectorHigh = 0x08
void InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}


// High priority interrupt routine
#pragma code
#pragma interrupt InterruptHandlerHigh
void InterruptHandlerHigh ()
{
  static char i ; // doit tre statique pour conserver sa valeur entre les IT
//======== SERIAL======================
if(PIR1bits.RCIF) // si un car arrive
   {
   C1 =ReadUSART(); // le lire => RAZ  RCIF
   
 
   if(RCSTAbits.FERR==1 )
   {
     RCSTAbits.SPEN = 0 ;
     RCSTAbits.SPEN= 1 ;
     C1 =ReadUSART(); // le lire => RAZ  RCIF   
     C1 =0;
     }
   if (RCSTAbits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTAbits.CREN = 0 ;
       C1 =ReadUSART(); // le lire => RAZ  RCIF   
     
    } 
   while(BusyUSART()); // par scurit
   if (PORTBbits.RB1==0) WriteUSART(C1); // echo
     if( C1 == BS)
        {
         if(i>0){
             i--;  }
        }
      else {
      if(C1 != CR && i<MAX_LEN)
      {
        buffer[i++]=C1 ; // stockage
        }else
        {
         buffer[i]='\0'; // fin de chane si CR
         i=0;
         received =1;
       }
      }
    }
 // ===  Timer1 interrupt ====
   if ((PIR1bits.TMR1IF==1)&&(PIE1bits.TMR1IE==1))
      {
       count ++;
       if (count >DureeCycle)  // x 0.2S=> XXsec
        {
         count=0;
         TimeEcoule=1;
         // Led_Verte=!Led_Verte;
        }
        WriteTimer1(3035);    // 62500*8*4*0.1 => 200000S  =0,2sec
       PIR1bits.TMR1IF = 0;
      }

} // fin de routine interrupts


//--------- RS232 UART HARDWARE --------------


void Init_UART1(void) // 18f26K20 1 seul UART
{
// voir para 18.5 spec sheet DS41159B page 186
///USART_BRGH_HIGH
// 9600   65 @ 10MHz 
// 9600   130 @ 20MHz 
// 19200  32 @ 10MHz 
// 19200  52 @ 16Mhz
// 19200  64 @ 20MHz 
// 38400  32 @ 20MHz 
// 115200  10 @ 20MHz 
OpenUSART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
USART_BRGH_HIGH,52 // 19200  @ 16Mhz
); 
IPR1bits.RCIP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RCIE = 0;
INTCONbits.PEIE = 0 ; // autorisation des IT des priphriques
INTCONbits.GIE = 0 ; // autorisation globale des IT
}

int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(char * untel)
{
   	while(BusyUSART());
   	WriteUSART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

void Write_Word(unsigned int M,char Sign,char Bold)
{
// Sign 1 pour entier sign +32767 -32768     
// Sign 0 pour entier non sign 0 a 65535
// Bold =1 pour affichage double largeur sur nokia=Gras
// Bold=0 ecriture normale sur nokia
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];    // init ponteur sur zone rangement caracteres
 if (Sign>1) return;   // argument signe doit etre 0 ou 1 
 if (Sign==0)
  {       M1=(long)M;
        ultoa(M1,valtxt);
  }
  else itoa(M,valtxt);
 if (Drapeaux.Fill==1)
 {
  k=strlen(Entree);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Drapeaux.Blc==1) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
 if (Drapeaux.Lcd) nokia_print_str(valtxt,Bold); else k=PutStr_RS(valtxt);
}

void fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
x=x+0.00000125;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
//return (adpt);
}

void print_flt(float W,int NbDeci,char Bold)
{long lWhole;
 unsigned int ulPart;
 Drapeaux.Fill=0;
 lWhole=(long)(W);
 ulPart=(unsigned int)((W*(float)NbDeci)-(float)(lWhole*NbDeci));
 ultoa(lWhole,&Texte[0]);
 #ifdef NOKIA
 if (Drapeaux.Lcd) nokia_print_str(Texte,Bold);else k=PutStr_RS(Texte);
 if (Drapeaux.Lcd) nokia_printchar('.',Bold); else  Put_RS('.');
 #else
 k=PutStr_RS(Texte);
 Put_RS('.');
 #endif
  Write_Word(ulPart,0,Bold);
}

void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
       Put_RS(49u);  //  '1'
    else
       Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')
    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')                       // '9'= 57u
    low += 7;                         // > '9'
   Put_RS(high);
   Put_RS(low);
   Put_RS('h');
 }

void Tempo(long val)
{
while(val>0){val--;}
}

void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)
 {
  Put_RS(' ');
 }
}

//---- EEPROM PIC
unsigned char EEPROM_Lect(unsigned char adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);

//------  EEPROM du PIC ---------------

unsigned char EEPROM_Lect(unsigned char adrL) // lecture a l'adresse adrL
{
	EEADR=adrL;
	EEADRH=0,
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned char adrE,unsigned char car) // ecrit  a l'adresse adrE
{
	EEADR= adrE;
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(int PtrE)
{ int i;
  do
  {
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;

  Put_RS((Byte)i);
  PtrE++;
  if ( PtrE > 255) break;
   }
  while (i!=0)  ;
 Tempo(15000L);
}

void Init_Hardware()
 {
   PORTB = 0xFF;
   TRISB = 0xFF;
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=1;   	// B1 input for debug echo reception
   TRISBbits.TRISB2=0;   	// B2 led
   TRISBbits.TRISB3=1;		// B3 not used
   TRISBbits.TRISB4=1;		// B4 not used
   TRISBbits.TRISB5=1;		// B5 not used
   TRISBbits.TRISB6=1;      //  B6 not used
   TRISBbits.TRISB7=1;      //  B7 not used

  TRISA = 0b00000111 ;   // PORTA is RA0,1,2,= Digital input  RA3,4,5=Digital output
  LATA = 0x00;
  
  ANSELH=0;   // Porb  RB0 ..RB4 as digital
  ANSEL=1;   // RA0 as analog

  

  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0b10000000;    // all output expect RC7
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 0;
  TRISCbits.TRISC3 = 0;
  TRISCbits.TRISC4 = 0;
  TRISCbits.TRISC5 = 0;
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  
  SLRCON=0;
 }

void Init_Timer1()
{
 //--- init timer1 18f26k20
 OpenTimer1(TIMER_INT_ON &
  T1_16BIT_RW &
  T1_SOURCE_INT &
  T1_PS_1_8 &
  T1_OSC1EN_OFF &
  T1_SYNC_EXT_OFF
  );
  T1CONbits.TMR1CS=0;
  T1CONbits.T1OSCEN=0;
   T1CONbits.T1RUN=0;      // don't uses Timer1 Oscillator
  T1CONbits.RD16=1;       // timer mode 16 bits
  IPR1bits.TMR1IP=1;      // set hihh priority for Timer1
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  WriteTimer1(3035);      // 62500*8*4*0.1 => 200000S  =0,2sec
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  INTCONbits.PEIE = 1;    // enable interupt Peripheriques
  T1CONbits.TMR1ON=0;     // desactive Timer1
  PIE1bits.TMR1IE=1;      // Enable Interrupt Timer1
  INTCONbits.GIE = 1;     // active global interrupt
  INTCONbits.GIEL=1;      // active les priorites  (par8 page 79 docu PIC18Fxx8)
 
}

void main()
{
    
#ifdef OSCILLATEUR_INTERNE
  OSCCON=0x70;         // Select 16 MHz internal clock  et 19200 bds
//   OSCCON=0x60;         // Select 8 MHz internal clock  et 9600 bds
 //   OSCCON=0x50;         // Select 4 MHz internal clock et 4800bds
 //   OSCCON=0x40;         // Select 2 MHz internal clock et 2400bds
 //   OSCCON=0x30;         // Select 1 MHz internal clock et 1200bds
   
#endif
 Init_Hardware() ;
 Led_Rouge=Allume;
// init des pointeurs stockage reception car
 received=0;
 Drapeaux.Fill=1;
 Drapeaux.Blc=1;
 
 Init_UART1();
 OUT_RS232
 while(DataRdyUSART())
 {
  Dummy=getcUSART();
  }
 Put_RS(CLS);
 Tempo(100000L);
 Led_Rouge=Eteint;
 CptCars=0;
 count=0;
 CRLF();
 txt=&Texte[0];
 //probleme !
 //txt=strcpy(Texte[0],"18F26K20_Nokia_120212.c  string en RAM\n\r");
 //k=PutStr_RS(txt);

 CRLF();
 Led_Rouge=Allume;
 txt=&Texte[0];
 //putrsUSART(RS_Str[1]); // en ROM
 //strcpypgm2ram(txt,RS_Str[1]);
 //k=PutStr_RS(txt);
 Tempo(1000L) ;
 PrintOut_Eeprom_Msg(0);    
  PrintOut_Eeprom_Msg(0x20); 
   PrintOut_Eeprom_Msg(0x60);   
      PrintOut_Eeprom_Msg(0x80);  
        PrintOut_Eeprom_Msg(0xA0);    
          PrintOut_Eeprom_Msg(0xC0); 
              PrintOut_Eeprom_Msg(0xE0); 
          

  CRLF();
 Led_Rouge=Eteint;
 Tempo(1000L) ;
 
 //--- initialisation Nokia 5110 ---
 OUT_LCD
 Delay_mS(100);
 
 // nokia_Power=1;     // alimente le LCD
 // pas possible sous 2,6V seulement
 Delay_mS(500);
 nokia_init();
  
 Led_Rouge=!Led_Rouge;
 nokia_clean_ddram();
 nokia_CLS();
  Delay_mS(100);
 for (i=0;i<5;i++)
 {
  nokia_gotoxy(0,i); 
  strcpypgm2ram(&Texte[0],Nokia_Str[i]); 
  nokia_print_str(Texte,0);
  Delay_1S();  
 }
 Led_Rouge=!Led_Rouge;


 count=0;
  // init Interupt usart1
  RCSTAbits.CREN= 1 ;
  PIE1bits.RCIE = 1;
  INTCONbits.PEIE = 1;    // enable interupt Peripheriques
  INTCONbits.GIE = 1 ; // autorisation globale des IT, dont UART en reception
  received=0;
  buffer[0]=0;
  
 
// goto graf;

j=0;
 l=0; 
  nokia_gotoxy(0,4); 
  strcpypgm2ram(&Texte[0],Nokia_Str[6]);
  nokia_print_str(Texte,0); 
 OUT_RS232;  k=PutStr_RS(txt); CRLF(); OUT_LCD

 
 
 do
 {
 Led_Rouge=!Led_Rouge;
 nokia_gotoxy(12,4); 
 Write_Word(l,0,1); 
 Delay_mS(100);
 f1=(float)l*0.048;
 fltToa (f1,  ValFt1,3);
 
// calibre info flottant sur 7 caracteres 
 k=strlen(ValFt1);
 *(ValFt1+8)=0; // set maximum lenght
 if (k<7)
 { strcpy(txt+7-k,ValFt1);
   k=7-k;
   for (i=0;i<k;i++)txt[i]=' ';  
  }   
 strcpy(ValFt1,txt);
    
 nokia_gotoxy(0,5);
 txt=&Texte[0];
 strcpypgm2ram(txt,Nokia_Str[7] ); nokia_print_str(txt,0);
 txt=&Texte[0];
 nokia_gotoxy(12,5);
 nokia_print_str(ValFt1,0);nokia_print_degree();nokia_printchar('C',0);
 OUT_RS232;  Put_RS('T');  Put_RS('=');k=PutStr_RS(ValFt1);CRLF();  OUT_LCD
 Delay_mS(100);

 l=l+256;


 if (received)
 { 
     if( buffer[0]=='E')   // Eclairage
      {
        nokia_Power=0;
       }
     if ( (buffer[0]=='A') )   // chauffage
      {
         nokia_Power=1;
    
      }
  PIE1bits.RCIE = 1;
  INTCONbits.PEIE = 1;    // enable interupt Peripheriques
  INTCONbits.GIE = 1 ; // autorisation globale des IT, dont UART en reception
  received=0;
  buffer[0]=0;  
   }
 OUT_RS232
 Write_Word(j,0,0);
 CRLF();
 OUT_LCD
 j=j+256;
 if (j>1023) j=0;
 
 nokia_erase_y(3);
 for (i=0;i<78;i++)
 {
     if (i>0)
     {   nokia_gotoxy(i-1,3);
         nokia_printchar(' ',0);
     }    
     nokia_gotoxy(i,3);
     nokia_print_rightarrow();
     Delay_mS(20);
 }
  Delay_1S();
  // 6 pixels par char sens X
  nokia_erase_y(3);
 for (i=78;i>0;i--)
 {
     nokia_gotoxy(i,3);
     nokia_print_rightarrow();
        Delay_mS(20);
 }

 
 } 
while( l<1023);
l=0;
//toggle=0;   // efface (And)
//toggle=1;   // affiche (Or)
//toggle=2;   // reverse (Xor)

graf:
toggle=1; 

#ifdef With_Grafique
      // ********* test fonctions grafiques ***********
 do
 {
    k=fprintf(_H_USART,(const rom unsigned char *)"\r\nTest fonctions grafiques\r\n"); 
    nokia_CLS();
    //nokia_clean_ddram();
    k=fprintf(_H_USART,(const rom unsigned char *)"Test Rectangle 1,1,83,46,mode=%d\r\n",toggle); 
    nokia_rect(1,1,83,46,toggle);
    Delay_mS(100);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test Rectangle 10,10,73,36,mode=%d\r\n",toggle);  
    nokia_rect(10,10,73,36,toggle);
     Delay_mS(100);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test Rectangle 20,20,63,26,mode=%d\r\n",toggle); 
    nokia_rect(20,20,63,26,toggle);
   Delay_mS(100);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test circle 42,23,20,mode=%d\r\n",toggle); 
    nokia_circle(42,23,20,toggle);
     Delay_mS(100);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test circle 42,23,15,mode=%d\r\n",toggle); 
    nokia_circle(42,23,15,toggle);
     Delay_mS(100);
    k=fprintf(_H_USART,(const rom unsigned char *)"Test circle 42,23,10,mode=%d\r\n",toggle); 
    nokia_circle(42,23,10,toggle);
    Delay_xS(2);
    nokia_CLS();
    /*
    k=fprintf(_H_USART,(const rom unsigned char *)"Plot Y Value dot \r\n");
    nokia_plot(10,5,1);
    Delay_mS(100);
    nokia_plot(60,40,1);
    Delay_mS(100);
    Delay_xS(3);
    */
     k=fprintf(_H_USART,(const rom unsigned char *)"Plot Y vetical bar \r\n");
    nokia_CLS(); 
    nokia_clean_ddram();
    for (i=0;i<80;i=i+10)
    {
    nokia_plot(i,i/2,0);
    Delay_mS(100);
    }
    Delay_mS(2000);
    
   /*
    nokia_CLS();
    nokia_clean_ddram(); Delay_mS(10);
    k=fprintf(_H_USART,(const rom unsigned char *)"3 lines  using nokia_pixel cde \r\n");
    for (i=0;i<83;i++)
    {
      nokia_pixel(i,5,1);
      nokia_pixel(i,23,1);
      nokia_pixel(i,40,1);
    };
    nokia_redraw();
    Delay_mS(1000);
   */
    
    nokia_CLS();
    nokia_clean_ddram();
    k=fprintf(_H_USART,(const rom unsigned char *)"3 lines  using nokia_line cde \r\n");
    nokia_line(1,1,83,1,1);
    nokia_line(1,23,83,23,1);
    nokia_line(1,46,83,46,1);
    nokia_redraw(); // sinon pas de transfer LCDcache -> ram LCD
    Delay_xS(2);
    
    nokia_gotoxy(0,0);
    nokia_printchar('0',0);
    nokia_gotoxy(0,5);
    nokia_printchar('4',0); nokia_printchar('7',0);
    nokia_gotoxy(72,5);  // 84-2x6=72
    nokia_printchar('8',0); nokia_printchar('3',0);
    Delay_xS(2);
    
    nokia_CLS();
    nokia_clean_ddram();
    k=fprintf(_H_USART,(const rom unsigned char *)"Plot Sinusoide \r\n");
    for (i=0;i<359;i++)
    {   f2=(float)i * 3.14159 / 180.0;
        f1=sin(f2);
        f1=23.0-(f1*15.0);
        f2=(float)i*84.0/360.0;
        fltToa (f1,  ValFt1,3);
        fltToa (f2,  ValFt2,3);
        x=(unsigned int)f2;
        y=(unsigned int) f1;
     //   k=fprintf(_H_USART,(const rom unsigned char *)"i=%03d x=%s y=%s \r\n",i,ValFt1,ValFt2);
     //  pour verif calcul  sinusoide
         nokia_pixel(x,y,1); // ecretage positif de la sinusoide ????
         if (i %15==0) nokia_line(i,21,i,25,1);
       }   
    k=fprintf(_H_USART,(const rom unsigned char *)"Rajout des axes \r\n");
    
    nokia_line(0,23,83,23,1); // axe H
    nokia_line(0,0,0,47,1);   // axe V
    for (i=0;i<47;i=i+8) nokia_line(0,i,2,i,1);
   	nokia_redraw();
    Delay_xS(3);
    
   k=fprintf(_H_USART,(const rom unsigned char *)"BarGraph Horizontal (Y=1 ligne de cars) \r\n");
   nokia_CLS();
   nokia_clean_ddram();
    for (i=0;i<1023;i=i+32)
   {
        nokia_bargraph_H(3,i);
        Delay_mS(5);
    }  
     Delay_xS(3);  
    // toggle=toggle+1;
    // if (toggle>2) toggle=1;
    CRLF();
 }
 while(1);
#else
 while(1);
#endif

}


/*
18F26K20_test_Nokia_5110_LCD. 
Port Com 19200b & Init HARD.  
Avec UART HARDWARE........... 
18F26K20  Fosc=16Mhz 24/02/14 
paulfjujo@free.fr             
MPLAB IDE V8.92  C18 v3.45.01 
Nokia 5110 84x48 6Lx14cars

J=......... Pt
T=  0.000
00000
T= 12.288
00256
T= 24.576
00512
T= 36.864
00768

Test fonctions grafiques
Test Rectangle 1,1,83,46,mode=1
Test Rectangle 10,10,73,36,mode=1
Test Rectangle 20,20,63,26,mode=1
Test circle 42,23,20,mode=1
Test circle 42,23,15,mode=1
Test circle 42,23,10,mode=1
Plot Y vetical bar 
3 lines  using nokia_line cde 
Plot Sinusoide 
Rajout des axes 
*/